#ifndef DataField_h
#define DataField_h


namespace fastmrc
{
class DECLSPEC DataField :public Field
{
	typedef std::vector<Subfield*> SubfieldList; // vector faster than list in this case
	DataField(const DataField&);
	DataField& operator=(const DataField&);
public:
	typedef SubfieldList::const_iterator SubfieldListCIt;

	DataField(const char* data, unsigned datalen);

	virtual ~DataField(void);

	virtual bool isControl(void) const
	{
		return false;
	}

	char getInd1() const;
	char getInd2() const;

	SubfieldListCIt getSFListBegin();

	SubfieldListCIt getSFListEnd();

	SubfieldListCIt getSubfield(char code, SubfieldListCIt _start);

	unsigned getSubfieldsCount() const;
protected:
	void clear();

	void readSubfields();

	SubfieldList *sflist;
};

} // namespace fastmrc

#endif //#ifndef DataField_h