#ifndef FieldTag_h
#define FieldTag_h

namespace fastmrc
{
class DECLSPEC FieldTag
{
	friend std::ostream& operator<<(std::ostream& os, const FieldTag& ft)
	{
		os.put(ft.tag>>16).put(ft.tag>>8).put(ft.tag);
		return os;
	}

	friend inline bool operator<(const FieldTag& ftLeft, const FieldTag& ftRight)
	{
		return ftLeft.tag < ftRight.tag;
	}
public:
	// create FieldTag from char array
	// pcTag size must be at least 3 bytes
	// push 3 bytes into int
	explicit FieldTag(const char* pcTag);

	// converts this FieldTag to char array
	// pcTag size must be at least 4 bytes
	// returns pcTag
	char* ToAscii(char* pcTag) const;
private:
	int tag;
};


} // namespace fastmrc

#endif //#define FieldTag_h